#include<bits/stdc++.h>

using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()

const int inf = 1e9 + 7;


int n;

bool all_happy(vector<int> c, int k) {
    vector<int> dp(n + 1, 0);
    for (int i = 1; i < n; ++i) {
        if (c[i-1] <= i) dp[i] = dp[i - c[i-1]] + 1;
        dp[i] = max(dp[i], dp[i-1]);
    }
    if (c[n-1] <= n) dp[n] = dp[n - c[n-1]] + 1;
    return dp[n] >= k;
}

vector<int> c;

int get_ans(int k) {
    int l = 0;
    int r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        vector<int> copy(n - m, 1);
        copy.insert(copy.end(), c.begin(), c.begin() + m);
        if (all_happy(copy, k)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    c.resize(n);
    
    for (int i = 0; i < n; ++i) cin >> c[i];
    sort(all(c));

    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int k;
        cin >> k;
        cout << get_ans(k) << '\n';
    }

    return 0;
}
