#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x).size()
#define int int_fast32_t

#ifdef LOCAL
#include "../debug.h"
#else
#define debug(...) 1
#endif

constexpr int N = 4e5 + 5, Q = 1e6 + 10;
constexpr int K_seg = 300, K_ans = (N + K_seg - 1) / K_seg + 5;

int a[N], pos[N], res[Q];
int nearest[K_ans + 1];

signed main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    (void)freopen("../input.txt", "r", stdin);
#endif

    int n, q; cin >> n >> q;
    for (int i = 0; i < n; i++)
        cin >> a[i], a[i]--;

    for (int i = 0; i < n; i++)
        pos[a[i]] = i;

    fill(res, res + Q, n + 10);

    map<pair<int, int>, int> mem;

    vector<vector<pair<int, int>>> querys(n);
    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r;
        l--; r--;

        if (mem.count({ l, r })) {
            res[i] = mem[{ l, r }];
            continue;
        }

        if (r - l <= K_seg) {
            vector<int> c;
            for (int j = l; j <= r; j++)
                c.push_back(a[j]);
            sort(all(c));

            int now = INT_MAX;
            for (int i = 1; i < sz(c); i++)
                now = min(now, c[i] - c[i - 1]);
            res[i] = now;
            mem[{ l, r }] = now;
        } else {
            querys[l].emplace_back(r, i);
        }
    }

    fill(nearest, nearest + K_ans + 1, n);
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 1; j <= K_ans; j++) {
            for (int x : { a[i] - j, a[i] + j }) {
                if (0 <= x && x < n && pos[x] > i) {
                    nearest[j] = min(nearest[j], pos[x]);
                }
            }
        }

        for (auto &[r, idx] : querys[i]) {
            for (int j = 1; j <= K_ans; j++) {
                if (nearest[j] <= r) {
                    res[idx] = min(res[idx], j);
                    break;
                }
            }
        }
    }

    for (int i = 0; i < q; i++)
        cout << res[i] << "\n";


    return 0;
}

