#include "bits/stdc++.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define repr(i, n) for(int i = (n - 1); i >= 0; --i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using pi = pair<int, int>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 6e5;

const int K = 300;

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q; cin >> n >> q;
    vi a(n);
    rep(i, n) cin >> a[i];
    vi pos(n);
    rep(i, n) {
        a[i]--;
        pos[a[i]] = i;
    }
    vvi qs(n);
    vi l(q), r(q);
    vi ans(q, -1);
    rep(i, q) {
        cin >> l[i] >> r[i];
        l[i]--;
        r[i]--;
        qs[r[i]].push_back(i);
    }
    vi dp(K, -1);
    vi dp2(n, INFi);
    int len = 1;
    while(len * K - (K - 1) <= n) len++;
    for(int i = 0; i < n; ++i) {
        for(int j = max(a[i] - K + 1, 0); j < min(n, a[i] + K); ++j) {
            if (pos[j] < i) dp[abs(j - a[i])] = max(dp[abs(j - a[i])], pos[j]);
        }
        for(int j = i - 1; j >= max(i - len, 0); --j) {
            dp2[j] = min(dp2[j], min(dp2[j + 1], abs(a[i] - a[j])));
        }
        sort(all(qs[i]), [&] (const int &x, const int &y) {
            return l[x] < l[y];
        });
        int j = 0;
        rep(t, K) {
            while(j < qs[i].size() && l[qs[i][j]] <= dp[t]) {
                ans[qs[i][j++]] = t;
            }
        }
        while (j < qs[i].size()) {
            ans[qs[i][j]] = dp2[l[qs[i][j]]];
            j++;
        }
    }
    rep(i, q) {
        cout << ans[i] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}