#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <tuple>
#include <math.h>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <queue>
#include <random>
#include <array>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <unordered_map>

#define DEBUG
#define pqueue priority_queue
#define pb(x) push_back(x)
#define endl '\n'
#define all(x) x.begin(), x.end()
//#define int long long
#define mk(a, b) make_pair(a, b)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ull> vull;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pair<int, int> > vpii;
typedef pair<ll, ll> pll;
typedef vector<bool> vb;
typedef vector<string> vs;
typedef vector<vector<int> > vvi;
typedef vector<char> vc;

const ll inf = 1e9 + 228;
const ll infll = 1e18;
const int mod = 1e9 + 7;
const ll mod3 = 1e9 + 7;
const ld eps = 1e-7;
const ll mod2 = 1e9 + 9;
const ld PI = atan2l(0, -1);

void fast_io() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int k = 630;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> pos(n + 1);
    int cnt = 0;
    for (int &i: a) {
        cin >> i;
        pos[i] = cnt++;
    }
    vector<vector<pair<int, int>>> posts(n);
    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        posts[r].emplace_back(l, i);
    }
    for (int i = 0; i < n; i++) {
        sort(all(posts[i]));
    }
    vector<int> dp(n + 1, -1);
    vector<int> dp2(n + 1, inf);
    vector<int> ans(q);
    for (int i = 0; i < n; i++) {
        for (int j = max(a[i] - k, 1); j <= min(a[i] + k, n); j++) {
            if (pos[j] < i) {
                dp[abs(a[i] - j)] = max(dp[abs(a[i] - j)], pos[j]);
            }
        }
        for (int j = i - 1; j >= max(i - k, 0); j--) {
            dp2[j] = min({dp2[j], dp2[j + 1], abs(a[i] - a[j])});
        }
        int pnt = 0;
        for (int j = 1; j <= k; j++) {
            while (pnt < posts[i].size() && posts[i][pnt].first <= dp[j]) {
                ans[posts[i][pnt++].second] = j;
            }
        }
        for (int j = pnt; j < posts[i].size(); j++) {
            ans[posts[i][j].second] = dp2[posts[i][j].first];
        }
    }
    for (int i: ans)
        cout << i << endl;
}


signed main() {
    fast_io();
    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}
