#include <bits/stdc++.h>
#include "testlib.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;

const int MIN_PRICE = 1;
const int MAX_PRICE = 1'000'000'000;

const int MIN_N = 1;
const int MAX_N = 1'000'000'000;

const int MIN_M = 1;
const int MAX_M = 1'000'000'000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    string mode = opt<string>("mode", "rand");
    int a = opt<int>("a", -1);
    int b = opt<int>("b", -1);
    int n = opt<int>("n", -1);
    int m = opt<int>("m", -1);
    if (mode == "diffk") {
        if (n == -1) n = rnd.next(MIN_N, MAX_N);    
        int k = opt<int>("k"); 
        m = rnd.next(MIN_M, min(n, MAX_PRICE - k - 1));
        int c = rnd.next(MIN_PRICE, (MAX_PRICE - k) / (m + 1));
        a = c * (m + 1) + k;
        b = a - c;
        assert(1ll * b * (m + 1) == 1ll * a * m + k);
    } else if (mode == "rand") {
        a = rnd.next(MIN_PRICE, a == -1 ? MAX_PRICE : a);
        b = rnd.next(MIN_PRICE, b == -1 ? MAX_PRICE : b);
        n = rnd.next(MIN_N, n == -1 ? MAX_N : n);
        m = rnd.next(MIN_M, m == -1 ? MAX_M : m);
    }
    if (a == -1) a = rnd.next(MIN_PRICE, MAX_PRICE);
    if (b == -1) b = rnd.next(MIN_PRICE, MAX_PRICE);
    if (n == -1) n = rnd.next(MIN_N, MAX_N);
    if (m == -1) m = rnd.next(MIN_M, MAX_M);
    
    m = min(m, n + 1);
    
    cout << a << '\n' << b << '\n';
    cout << n << '\n' << m << '\n';
    return 0;
}


