#include "testlib.h"
#include <bits/stdc++.h>
#define all(arr) arr.begin(), arr.end()

using namespace std;

const int MaxN[] = {200'000, 400, 5000, 200'000, 200'000};

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	int gr_n = validator.group().empty() ? 0 : stoi(validator.group());
	int n = inf.readInt(1, MaxN[gr_n], "n");
	inf.readEoln();
	vector<int> prr = inf.readInts(n, 1, n, "p");
	inf.readEoln();
	vector<int> qrr = inf.readInts(n, 1, n, "q");
	inf.readEoln();
	if (gr_n == 3) {
		ensuref(is_sorted(all(prr)), "Expected p_i = i for group 3");
		reverse(all(qrr));
		ensuref(is_sorted(all(qrr)), "Expected q_i = n - i + 1 for group 3");
	}
	sort(all(prr));
	ensuref(unique(prr.begin(), prr.end()) == prr.end(), "Expected permutation (p is not)");
	sort(all(qrr));
	ensuref(unique(qrr.begin(), qrr.end()) == qrr.end(), "Expected permutation (q is not)");
	inf.readEof();
}