#include <bits/stdc++.h>
#define int long long
 
using namespace std;
 
typedef pair<int, int> ipair;
 
const int MAXN = 200200;
const int INF = 1e9;
 
struct gorilla {
	int a, b, c, d;
};
 
int n;
int prr[MAXN], qrr[MAXN], posp[MAXN], posq[MAXN];
gorilla subr[MAXN];
 
inline int f(int x) {
	return (x <= 0 ? 0 : x * (x + 1) / 2);
}
 
inline int inter(const ipair &seg1, const ipair &seg2) {
	ipair seg {max(seg1.first, seg2.first), min(seg1.second, seg2.second)};
	return max(seg.second - seg.first + 1, 0LL);
}
 
inline int calc(int x) {
	auto [lp1, rp1, lq1, rq1] = subr[x];
	auto [lp2, rp2, lq2, rq2] = subr[x + 1];
	ipair slp = {0, lp1}, srp = {rp1, n - 1};
	ipair slq = {0, lq1}, srq = {rq1, n - 1};
	if (lp1 == lp2) srp = {rp1, rp2 - 1};
	else slp = {lp2 + 1, lp1};
	if (lq1 == lq2) srq = {rq1, rq2 - 1};
	else slq = {lq2 + 1, lq1};
	return inter(slp, slq) * inter(srp, srq);
}
 
void build() {
	for (int i = 0; i < n; ++i)
		posp[prr[i]] = posq[qrr[i]] = i;
	int lp = INF, rp = -INF;
	int lq = INF, rq = -INF;
	for (int x = 1; x <= n; ++x) {
		lp = min(lp, posp[x]), rp = max(rp, posp[x]);
		lq = min(lq, posq[x]), rq = max(rq, posq[x]);
		subr[x] = {lp, rp, lq, rq};
	}
}
 
int solve() {
	int l = min(posp[1], posq[1]);
	int r = max(posp[1], posq[1]);
	int ans = f(l) + f(r - l - 1) + f(n - r - 1) + 1;
	for (int x = n - 1; x >= 1; --x)
		ans += calc(x);
	return ans;
}
 
signed main() {
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> prr[i];
	for (int i = 0; i < n; ++i)
		cin >> qrr[i];
	build();
	cout << solve() << endl;
}
