#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

int MaxN = 200'000;
 
int n;
vector<int> a;
 
inline int readAndCheckAnswer(InStream& in) {
    int l = in.readInt(-1, n, "l");
    if(l == -1)
        return l;
    
    int r = in.readInt(1, n, "r");
    
    if (r < l) {
        in.quitf(_wa, "Incorrect segment!");
    }
    
    if(r > n || l < 1){
        in.quitf(_wa, "Incorrect segment!");
    }
    
    int mx = 1;
    int mn = n;
    for (int i = l - 1; i <= r - 1; i++) {
        mx = max(mx, a[i]);
        mn = min(mn, a[i]);
    }
    
    if(a[l - 1] == mn || a[l - 1] == mx || a[r - 1] == mn || a[r - 1] == mx){
        in.quitf(_wa, "Segment doesn't fit condition!");
    }
    
    return 1;
}
 
int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
 
    n = inf.readInt(1, MaxN, "n");
    a.resize(n);
    for(int i = 0; i < n; i++)
        a[i] = inf.readInt(1, MaxN, "a_i");
 
    int ja = readAndCheckAnswer(ans);
    int pa = readAndCheckAnswer(ouf);
 
    if(ja == 1 && pa == -1)
        quitf(_wa, "Jury has the answer but participant has not");
    if(ja == -1 && pa == 1)
        quitf(_fail, "Participant has the answer but jury has not");
 
    quitf(_ok, "Ok!");
}
