// #include "/home/tikhon/Downloads/testlib-master/testlib.h"
#include "testlib.h"

#include <bits/stdc++.h>
using namespace std;

#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
map<string, string> params;

vector<string> mods = {"rand", "better_rand"};
string mode = "any";

void gen(int n, int q, int k, vector<int>& c, vector<int>& ask) {
    c.resize(n, 1);  // 1...n
    ask.resize(q);  // 2..k

    if (mode == "rand") {
        for (int i = 0; i < n; ++i) {
            c[i] = rnd.next(1, n);
        }
        for (int i = 0; i < q; ++i) {
            ask[i] = rnd.next(2, k);
        }
    }

    if (mode == "better_rand") {
        for (int i = 0; i < n; ++i) {
            int k = rnd.next(1, (int)sqrt(n));
            c[i] = rnd.next(k * k, min((k+1) * (k+1) - 1, n));
        }

        for (int i = 0; i < q; ++i) {
            ask[i] = rnd.next(2, k);
        }
    }

    if (q == 1) ask[0] = k;
    shuffle(all(c));
    shuffle(all(ask));
}


int main(int argc, char* argv[]){
    registerGen(argc, argv, 1);

    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        }
    }


    int n = stoi(params["n"]);
    int q = stoi(params["q"]);
    int k_maxk = stoi(params["k"]);

    if (params.count("mode"))
        mode = params["mode"];
    if (mode == "any")
        mode = rnd.any(mods);

    vector<int> c, ask;

    gen(n, q, k_maxk, c, ask);

    cout << n << '\n';
    cout << c[0];
    for (int i = 1; i < n; ++i) {
        cout << ' ' << c[i];
    }
    cout << '\n';
    cout << q << '\n';
    for (int i = 0; i < q; ++i) {
        cout << ask[i] << '\n';
    }

    return 0;
}
