#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <tuple>
#include <math.h>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <queue>
#include <random>
#include <array>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <unordered_map>

#define DEBUG
#define pqueue priority_queue
#define pb(x) push_back(x)
#define endl '\n'
#define all(x) x.begin(), x.end()
//#define int long long
#define mk(a, b) make_pair(a, b)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ull> vull;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pair<int, int> > vpii;
typedef pair<ll, ll> pll;
typedef vector<bool> vb;
typedef vector<string> vs;
typedef vector<vector<int> > vvi;
typedef vector<char> vc;

const ll inf = 1e9 + 228;
const ll infll = 1e18;
const int mod = 1e9 + 7;
const ll mod3 = 1e9 + 7;
const ld eps = 1e-7;
const ll mod2 = 1e9 + 9;
const ld PI = atan2l(0, -1);

void fast_io() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i: a)
        cin >> i;
    sort(all(a));
    vector<int> dp(n + 1, -inf);
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        if (a[i - 1] <= i) {
            dp[i] = dp[i - a[i - 1]] + 1;
        }
        dp[i] = max(dp[i], dp[i - 1]);
    }
    vector<int> ans(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        if (a[i - 1] <= i) {
            ans[dp[i] + n - i] = max(ans[dp[i] + n - i], i);
        } else {
            if (a[i - 1] <= n) {
                ans[1 + n - a[i - 1]] = max(ans[1 + n - a[i - 1]], i);
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        ans[i] = max(ans[i], ans[i + 1]);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int a;
        cin >> a;
        cout << ans[a] << endl;
    }
}

/*
5
1 2 2 2 2
3
2
3
4
=====
6
1 2 3 4 5 6
2
2
3
 */

signed main() {
    fast_io();
    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}