#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;


//                       0      1    2     3        4       5       6       7       8       9
const int MaxN[11] = { 400000, 50, 3000, 50000, 100000, 100000, 200000, 300000, 400000, 400000};
const int MaxQ[11] = {1000000, 50, 3000, 50000, 100000, 100000, 200000, 300000, 400000, 1000000};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    
    int gr_n = validator.group().empty() ? 0 : atoi(validator.group().c_str());
    
    int n = inf.readInt(2, MaxN[gr_n], "n is not in [2; " + to_string(MaxN[gr_n]) + "]");
    inf.readSpace();
    int q = inf.readInt(1, MaxQ[gr_n], "q is not in [1; " + to_string(MaxQ[gr_n]) + "]");
    inf.readEoln();
    vector<bool> used(n, false);
    
    for(int i=0; i<n; i++){
        int a_i = inf.readInt(1, n, "a_i is not in [1; " + to_string(n) + "]!");
        used[a_i - 1] = true;
        if(i != n - 1){
            inf.readSpace();
        }
    }
    inf.readEoln();
    for(int i=0; i<n; i++){
        ensuref(used[i], "it is not a permutation!");
    }
    set<int> lens;
    for(int i=0; i<q; i++){
        int l_i = inf.readInt(1, n - 1, "l_i is not in [1; " + to_string(n) + "]!");
        inf.readSpace();
        int r_i = inf.readInt(l_i + 1, n, "r_i is not in [" + to_string(l_i + 1) + "; " + to_string(n) + "]!");
        lens.insert(r_i - l_i);
        inf.readEoln();
    }
    if(gr_n == 4){
        ensuref(lens.size() == 1, "Not equal lengths!");
    }
    inf.readEof();
}


