#include "testlib.h"

using namespace std;

const int MIN_PRICE = 1;
const int MAX_PRICE = 1'000'000'000;

const int MIN_N = 1;
const int MAX_N = 1'000'000'000;

const int MIN_M = 1;
const int MAX_M = 1'000'000'000;


int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    
    int gr_n = validator.group().empty() ? 0 : atoi(validator.group().c_str());

    int a = inf.readInt(MIN_PRICE, MAX_PRICE, "a");
    inf.readEoln();
    int b = inf.readInt(MIN_PRICE, MAX_PRICE, "b");
    inf.readEoln();
    
    int n = inf.readInt(MIN_N, MAX_N, "n");
    inf.readEoln();
    int m = inf.readInt(MIN_M, MAX_M, "m");
    inf.readEoln();
    
    inf.readEof();
    
    if(gr_n == 1){
        ensuref(m == 1, "m is not 1");
    } else if(gr_n == 2){
        ensuref(n <= 1e6, "n is not less than 1e6");
    }
    return 0;
}
